
#include "cjppa.h"
#include "cjpp.h"

#include <malloc.h>
#include <stdio.h>


/*This Funktions must be implemented for different Platforms*/

DWORD WINAPI SerialPollThread(cjccidHANDLE hDevice)
{
   while(!hDevice->backs.Fini)
   {
      if(cjppDoPoll(&(hDevice->cjppStr),&(hDevice->backs.Fini))!=CJPP_SUCCESS)
		{
			hDevice->cjppStr.Connected=0;
 	   	return 0;
		}
	}
	hDevice->cjppStr.Connected=0;
	return 0;
}

int cjppDoPoll(cjppHANDLE hDevice, int *Fini)
{
	DWORD Status;
	DWORD Rts=SETRTS;
	OVERLAPPED over;
	memset(&over,0,sizeof(over));
	over.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
	if(GetCommModemStatus(hDevice->hDevice,&Status))
	{
		if((Status&MS_CTS_ON)==MS_CTS_ON)
			Rts=CLRRTS;
		for(;!(*Fini);)
		{
   		EscapeCommFunction(hDevice->hDevice,Rts);
			if(!WaitCommEvent(hDevice->hDevice,&Status,&over))
			{
            if(GetLastError()!=ERROR_IO_PENDING)
				{
					*Fini=1;
				}
				else
				{
					if(WaitForSingleObject(over.hEvent,100)==WAIT_TIMEOUT)
					{
						*Fini=1;
					}
					else
					{
						if(Rts==SETRTS)
							Rts=CLRRTS;
						else
							Rts=SETRTS;
						Sleep(500);
					}
				}
			}
			else
			{
				if(Rts==SETRTS)
					Rts=CLRRTS;
				else
					Rts=SETRTS;
				Sleep(500);
			}
		}
	}
	else
	{
		*Fini=1;
	}
   SetEvent(hDevice->o_receive.hEvent);
	CloseHandle(over.hEvent);
	return CJPP_ERR_DEVICE_LOST;
}

int cjppSeriellWaitInt(cjppHANDLE hDevice,CCID_Interrupt *Intr,int *Fini)
{
   unsigned char buffer[272];
   DWORD nRet;
	int i;
	DWORD len;
	unsigned char add;
	unsigned char lrc;
	unsigned char *ptr;
	BOOL bSend=FALSE;


   for(;!(*Fini);)
   {
      nRet=0;
      ResetEvent(hDevice->o_receive.hEvent);
      hDevice->o_receive.Offset=0;
      hDevice->o_receive.OffsetHigh=0;
		hDevice->o_receive.Internal=0;
		hDevice->o_receive.InternalHigh=0;
		memset(buffer,0,sizeof(buffer));
		CancelIo(hDevice->hDevice);
   	if(ReadFile(hDevice->hDevice,buffer,1,&nRet,&(hDevice->o_receive))==0)
		{
			if(bSend)
			{
 			   SetEvent(hDevice->SeriellReaderWait);
				bSend=FALSE;
			}
			if(GetLastError()==ERROR_IO_PENDING)
			{
		      if(WaitForSingleObject(hDevice->o_receive.hEvent,INFINITE)==WAIT_OBJECT_0)
					nRet=1;
//   				GetOverlappedResult(hDevice->hDevice,&(hDevice->o_receive),&nRet,FALSE);
			}
		}
      //cjppDebugOut(hDevice,"Running",1,buffer);
		if(nRet!=1 || *Fini)
		{
			nRet=0;
			continue;
		}
//      cjppDebugOut(hDevice,"Firstbyte",1,buffer);
		
		if((buffer[0]==0 || buffer[0]==0xff) && hDevice->WaitAck==1)
		{
         hDevice->rbuffer[0]=buffer[0];
			if(buffer[0]==0xff)
   			hDevice->WaitAck=2;
			SetEvent(hDevice->SeriellAckWait);
//         cjppDebugOut(hDevice,"Acknoldge",1,buffer);
		}
		else if(buffer[0]==RDR_TO_PC_NOTIFYSLOTCHANGE || buffer[0]==RDR_TO_PC_HARWAREERROR || buffer[0]==RDR_TO_PC_KEYEVENT)
		{
			nRet=0;
			ResetEvent(hDevice->o_receive.hEvent);
			hDevice->o_receive.Offset=0;
			hDevice->o_receive.OffsetHigh=0;
			hDevice->o_receive.Internal=0;
			hDevice->o_receive.InternalHigh=0;
   		if(ReadFile(hDevice->hDevice,buffer+1,3,&nRet,&(hDevice->o_receive))==0)
			{
				if(GetLastError()==ERROR_IO_PENDING)
				{
					if(WaitForSingleObject(hDevice->o_receive.hEvent,1000)==WAIT_OBJECT_0)
   					nRet=3;
//      				GetOverlappedResult(hDevice->hDevice,&(hDevice->o_receive),&nRet,FALSE);
				}
			}
			if(nRet!=3)
			{
				nRet=0;
				continue;
			}
//         cjppDebugOut(hDevice,"Interrupt",4,buffer);
			lrc=0;
			add=0;
			ptr=buffer;
			for(i=0;i<2;i++)
			{
				add+=*ptr;
				lrc^=*ptr++;
			}
			if(add==buffer[2] && lrc==buffer[3])
			{
				memcpy(Intr,buffer,2);
				break;
			}
		}
		else if(hDevice->WaitAck==2)
		{
			ResetEvent(hDevice->o_receive.hEvent);
			hDevice->o_receive.Offset=0;
			hDevice->o_receive.OffsetHigh=0;
			hDevice->o_receive.Internal=0;
			hDevice->o_receive.InternalHigh=0;
			nRet=0;
   		if(ReadFile(hDevice->hDevice,buffer+1,9,&nRet,&(hDevice->o_receive))==0)
			{
				if(GetLastError()==ERROR_IO_PENDING)
				{
					if(WaitForSingleObject(hDevice->o_receive.hEvent,1000)==WAIT_OBJECT_0)
   					nRet=9;
//      				GetOverlappedResult(hDevice->hDevice,&(hDevice->o_receive),&nRet,FALSE);
				}
			}
			if(nRet!=9)
			{
   			nRet=0;
				Sleep(200);
            PurgeComm(hDevice->hDevice,PURGE_RXCLEAR);
				buffer[0]=0;
   			if(WriteFile(hDevice->hDevice,buffer,1,&nRet,&(hDevice->o_transmit))==0)
				{
				  if(GetLastError()!=ERROR_IO_PENDING)
				  {
					  return CJPP_ERR_DEVICE_LOST;
				  }
				  else if(WaitForSingleObject(hDevice->o_transmit.hEvent,1000)==WAIT_TIMEOUT)
				  {
					 return CJPP_ERR_WRITE_DEVICE;
				  }
				}
	   		continue;
			}
//         cjppDebugOut(hDevice,"Header",10,buffer);
			len=cjppSWAB_DWORD_2(*(unsigned long *)(buffer+1));
			ResetEvent(hDevice->o_receive.hEvent);
			hDevice->o_receive.Offset=0;
			hDevice->o_receive.OffsetHigh=0;
			hDevice->o_receive.Internal=0;
			hDevice->o_receive.InternalHigh=0;
			nRet=0;
   		if(ReadFile(hDevice->hDevice,buffer+10,len+2,&nRet,&(hDevice->o_receive))==0)
			{
				if(GetLastError()==ERROR_IO_PENDING)
				{
					if(WaitForSingleObject(hDevice->o_receive.hEvent,1000)==WAIT_OBJECT_0)
   					nRet=len+2;
//      				GetOverlappedResult(hDevice->hDevice,&(hDevice->o_receive),&nRet,FALSE);
				}
			}
			if(nRet!=len+2)
			{
				Sleep(200);
            PurgeComm(hDevice->hDevice,PURGE_RXCLEAR);
				buffer[0]=0;
   			if(WriteFile(hDevice->hDevice,buffer,1,&nRet,&(hDevice->o_transmit))==0)
				{
				  if(GetLastError()!=ERROR_IO_PENDING)
				  {
					  return CJPP_ERR_DEVICE_LOST;
				  }
				  else if(WaitForSingleObject(hDevice->o_transmit.hEvent,1000)==WAIT_TIMEOUT)
				  {
					 return CJPP_ERR_WRITE_DEVICE;
				  }
				}
				nRet=0;
				continue;
			}
//         cjppDebugOut(hDevice,"Block",len+12,buffer);

			lrc=0;
			add=0;
			ptr=buffer;
			for(i=0;i<len+10;i++)
			{
				add+=*ptr;
				lrc^=*ptr++;
			}
			ResetEvent(hDevice->o_transmit.hEvent);

			nRet=0;
			hDevice->o_transmit.Internal=0;
			hDevice->o_transmit.InternalHigh=0;
			hDevice->o_transmit.Offset=0;
			hDevice->o_transmit.OffsetHigh=0;
			if(add==buffer[10+len] && lrc==buffer[11+len])
			{
				memcpy(hDevice->rbuffer,buffer,270);
				buffer[0]=0xff;
   			if(WriteFile(hDevice->hDevice,buffer,1,&nRet,&(hDevice->o_transmit))==0)
				{
				  if(GetLastError()!=ERROR_IO_PENDING)
				  {
					  return CJPP_ERR_DEVICE_LOST;
				  }
				  else if(WaitForSingleObject(hDevice->o_transmit.hEvent,1000)==WAIT_TIMEOUT)
				  {
					 return CJPP_ERR_WRITE_DEVICE;
				  }
				}
   			hDevice->WaitAck=0;
				bSend=TRUE;
			}
			else
			{
				Sleep(200);
            PurgeComm(hDevice->hDevice,PURGE_RXCLEAR);
				buffer[0]=0;
   			if(WriteFile(hDevice->hDevice,buffer,1,&nRet,&(hDevice->o_transmit))==0)
				{
				  if(GetLastError()!=ERROR_IO_PENDING)
				  {
					  return CJPP_ERR_DEVICE_LOST;
				  }
				  else if(WaitForSingleObject(hDevice->o_transmit.hEvent,1000)==WAIT_TIMEOUT)
				  {
					 return CJPP_ERR_WRITE_DEVICE;
				  }
				}
				bSend=TRUE;
			}
		}
   }
   return CJPP_SUCCESS;

}

int cjppWaitInt(HANDLE hDevice,CCID_Interrupt *Intr,int *Fini)
{
   HANDLE Ev;
   unsigned char buffer[270];
   OVERLAPPED over;
   DWORD nRet;


   memset(&over,0,sizeof(over));
   Ev=over.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
   for(nRet=0;nRet==0 && !(*Fini);)
   {
      nRet=0;
      ResetEvent(over.hEvent);
      over.Offset=0;
      over.OffsetHigh=0;
      memcpy(buffer,"CJCC",4);
      if(!DeviceIoControl(hDevice,IOCTL_CCID_INT,NULL,0,buffer,270,&nRet,&over))
      {
         if(GetLastError()!=ERROR_IO_PENDING)
         {
           CloseHandle(over.hEvent);
           return CJPP_ERR_DEVICE_LOST;
         }
         GetOverlappedResult(hDevice,&over,&nRet,TRUE);
      }
   }
   memcpy(Intr,buffer,sizeof(CCID_Interrupt));
   CloseHandle(over.hEvent);
   return CJPP_SUCCESS;
}


DWORD WINAPI IntThread(cjccidHANDLE hDevice)
{
   CCID_Interrupt Intr;
   while(!hDevice->backs.Fini)
   {
     if(hDevice->cjppStr.is_usb)
	  {
         if(cjppWaitInt(hDevice->cjppStr.hDevice,&Intr,&(hDevice->backs.Fini))!=CJPP_SUCCESS)
			{
				hDevice->cjppStr.Connected=0;
      		return 0;
			}
	  }
	  else
	  {
         if(cjppSeriellWaitInt(&(hDevice->cjppStr),&Intr,&(hDevice->backs.Fini))!=CJPP_SUCCESS)
			{
            hDevice->cjppStr.Connected=0;
      		return 0;
			}
	  }
	  HandleCyberJackInterruptData(hDevice, &Intr);
   }
   hDevice->cjppStr.Connected=0;
	return 0;
}


HANDLE cjppCreate(char *cDeviceName)
{
   HANDLE hDevice;
   char *myName=strdup(cDeviceName);
   strupr(myName);
   if(strstr(myName,"COM")!=NULL)
   {

      hDevice=CreateFile(cDeviceName,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED | FILE_FLAG_NO_BUFFERING,NULL);
	  if(hDevice!=INVALID_HANDLE_VALUE)
	  {
         DCB dcb;
         COMMTIMEOUTS timeout;
		   memset(&dcb,0,sizeof(dcb));
		   dcb.DCBlength=sizeof(dcb);

		   timeout.ReadIntervalTimeout=0;
		   timeout.ReadTotalTimeoutMultiplier=0; 
		   timeout.ReadTotalTimeoutConstant=0; 

//			timeout.ReadIntervalTimeout=1000; 
//		   timeout.ReadTotalTimeoutMultiplier=1000; 
//		   timeout.ReadTotalTimeoutConstant=1000; 
		   timeout.WriteTotalTimeoutMultiplier=1000; 
		   timeout.WriteTotalTimeoutConstant=1000; 
		   dcb.fBinary=TRUE;
		   dcb.fParity=FALSE;
		   dcb.Parity=NOPARITY;
		   dcb.StopBits=ONESTOPBIT;
		   dcb.ByteSize=8;
		   dcb.BaudRate=CBR_115200;
		   dcb.fOutxCtsFlow=FALSE;
		   dcb.fOutxDsrFlow=FALSE;
		   dcb.fDtrControl=DTR_CONTROL_DISABLE;
		   dcb.fDsrSensitivity=FALSE;
		   dcb.fRtsControl=RTS_CONTROL_DISABLE;
		   dcb.wReserved=0;
		   dcb.fOutX=FALSE;
		   dcb.fInX=FALSE;
		   dcb.fErrorChar=FALSE;
		   dcb.fNull=FALSE;
		   dcb.fAbortOnError=FALSE;


			SetupComm(hDevice,272,272);
		   SetCommState(hDevice,&dcb);
		   SetCommTimeouts(hDevice,&timeout);
		   SetCommMask(hDevice,EV_CTS);
         SetCommBreak(hDevice);
			Sleep(1);
         ClearCommBreak(hDevice);
         PurgeComm(hDevice,PURGE_TXCLEAR | PURGE_RXCLEAR | PURGE_RXABORT);
			Sleep(1);
	  }
   }
   else
      hDevice=CreateFile( cDeviceName,

							  GENERIC_READ | GENERIC_WRITE,
							  0,
							  NULL,
							  OPEN_EXISTING,
							  FILE_FLAG_OVERLAPPED,
							  (HANDLE)NULL);
   free(myName);
   if(hDevice==INVALID_HANDLE_VALUE)
      return 0;
   return hDevice;
}


unsigned long cjppGetLocalInfo(void)
{
 	HKEY hKey;
   unsigned long Result=0xffffffff;
   if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\REINER SCT\\cyberJack Base Components",0,KEY_READ,&hKey)==ERROR_SUCCESS)
   {
	 	DWORD dwLength;
      DWORD sCTHelp;
		dwLength=sizeof(sCTHelp);
		if(RegQueryValueEx(hKey,"pinpad2_info",NULL,NULL,(LPBYTE)&sCTHelp,&dwLength)==ERROR_SUCCESS)
		{
			Result=sCTHelp;
		}
      RegCloseKey(hKey);
   }
   return Result;
}

void cjppFillDevice(cjppHANDLE hcjppDevice)
{
   hcjppDevice->o_transmit.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
   hcjppDevice->o_receive.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
	if(hcjppDevice->is_usb==0)
	{
		DWORD TimeA;
		DWORD TimeI;
		BOOL  dummy;
   	hcjppDevice->SeriellReaderWait=CreateEvent(NULL,FALSE,FALSE,NULL);
	   hcjppDevice->SeriellAckWait=CreateEvent(NULL,FALSE,FALSE,NULL);
	}
	hcjppDevice->Connected=1;
}

/*void cjppClose(HANDLE cjppDevice)
{
   CloseHandle(((cjppHANDLE)cjppDevice)->hDevice);
   CloseHandle(((cjppHANDLE)cjppDevice)->o_transmit.hEvent);
   CloseHandle(((cjppHANDLE)cjppDevice)->o_receive.hEvent);
	if(hcjppDevice->is_usb==0)
	{
      CloseHandle(((cjppHANDLE)cjppDevice)->SeriellReaderWait);
      CloseHandle(((cjppHANDLE)cjppDevice)->SeriellAckWait);
      CloseHandle(((cjppHANDLE)cjppDevice)->hTimer);
	}
}*/

void cjccidClose(HANDLE cjppDevice)
{
   CloseHandle(((cjppHANDLE)cjppDevice)->hDevice);
   CloseHandle(((cjppHANDLE)cjppDevice)->o_transmit.hEvent);
   CloseHandle(((cjppHANDLE)cjppDevice)->o_receive.hEvent);
	if(((cjppHANDLE)cjppDevice)->is_usb==0)
	{
      CloseHandle(((cjppHANDLE)cjppDevice)->SeriellReaderWait);
      CloseHandle(((cjppHANDLE)cjppDevice)->SeriellAckWait);
	}
}


unsigned short cjppSWAB_WORD(unsigned short Value)
{
	return htons(Value);
}

unsigned long cjppSWAB_DWORD(unsigned long Value)
{
	return htonl(Value);
}

static unsigned short cjppSWAP_ALWAYS(unsigned short Value)
{
	unsigned char b;
   b=(unsigned char)(Value>>8);
   Value<<=8;
   return (unsigned short)(Value+b);
}

unsigned short cjppSWAB_WORD_2(unsigned short Value)
{
	Value=htons(Value);
	return cjppSWAP_ALWAYS(Value);

}

unsigned long cjppSWAB_DWORD_2(unsigned long Value)
{
   unsigned short w;
	Value=htonl(Value);
   w=cjppSWAP_ALWAYS((unsigned short)(Value>>16));
   Value=cjppSWAP_ALWAYS((unsigned short)Value);
   Value<<=16;
   return Value+w;
}

void cjppSleep(unsigned long Value)
{
   Sleep(Value);
}


int cjppWrite(HANDLE cjppDevice,CCID_Message *Message)
{
   unsigned char buffer[274];
   DWORD nRet;
   if(((cjppHANDLE)cjppDevice)->is_usb)
   {
		ResetEvent(((cjppHANDLE)cjppDevice)->o_transmit.hEvent);

		nRet=0;
		((cjppHANDLE)cjppDevice)->o_transmit.Internal=0;
		((cjppHANDLE)cjppDevice)->o_transmit.InternalHigh=0;
		((cjppHANDLE)cjppDevice)->o_transmit.Offset=0;
		((cjppHANDLE)cjppDevice)->o_transmit.OffsetHigh=0;
	    memcpy(buffer,"CJCC",4);
		memcpy(buffer+4,Message,270);
		if(WriteFile(((cjppHANDLE)cjppDevice)->hDevice,buffer,14+cjppSWAB_DWORD_2(Message->dwLength),&nRet,&(((cjppHANDLE)cjppDevice)->o_transmit))==0)
		{
		  if(GetLastError()!=ERROR_IO_PENDING)
		  {
			  return CJPP_ERR_DEVICE_LOST;
		  }
		  else if(WaitForSingleObject(((cjppHANDLE)cjppDevice)->o_transmit.hEvent,5000)==WAIT_TIMEOUT)
		  {
			 return CJPP_ERR_WRITE_DEVICE;
		  }
		}
   }
   else
   {
	   int i;
	   unsigned char addition;
		unsigned char lrc;
		unsigned char *ptr;
		BOOL HighResolution;
		LARGE_INTEGER Count;
		LARGE_INTEGER Start;
		LARGE_INTEGER Now;
		int len=cjppSWAB_DWORD_2(Message->dwLength);
      HighResolution=QueryPerformanceFrequency(&Count);
		if(HighResolution)
		{
   		Count.QuadPart/=2000;
	   	Count.QuadPart++;
		}
      do
		{

			ResetEvent(((cjppHANDLE)cjppDevice)->o_transmit.hEvent);
         //SetCommBreak(((cjppHANDLE)cjppDevice)->hDevice);
//			Sleep(1);
//         ClearCommBreak(((cjppHANDLE)cjppDevice)->hDevice);
//         PurgeComm(((cjppHANDLE)cjppDevice)->hDevice,PURGE_TXCLEAR | PURGE_RXCLEAR | PURGE_RXABORT);
			FlushFileBuffers(((cjppHANDLE)cjppDevice)->hDevice);
			Sleep(0);
   		if(HighResolution)
			{
				QueryPerformanceCounter(&Start);
				do
				{
   				QueryPerformanceCounter(&Now);
				}while(Now.QuadPart-Start.QuadPart<Count.QuadPart);
			}
			else
			{
				Sleep(1);
			}

			nRet=0;
			((cjppHANDLE)cjppDevice)->o_transmit.Internal=0;
			((cjppHANDLE)cjppDevice)->o_transmit.InternalHigh=0;
			((cjppHANDLE)cjppDevice)->o_transmit.Offset=0;
			((cjppHANDLE)cjppDevice)->o_transmit.OffsetHigh=0;
			addition=0;
			lrc=0;
			ptr=(unsigned char *)Message;
			memcpy(buffer,Message,10+len);
			for(i=0;i<10+len;i++)
			{
				addition+=*ptr;
				lrc^=*ptr++;
			}
			buffer[10+len]=addition;
			buffer[11+len]=lrc;

			((cjppHANDLE)cjppDevice)->WaitAck=1;
			ResetEvent(((cjppHANDLE)cjppDevice)->SeriellAckWait);
			ResetEvent(((cjppHANDLE)cjppDevice)->SeriellReaderWait);
			if(WriteFile(((cjppHANDLE)cjppDevice)->hDevice,buffer,5,&nRet,&(((cjppHANDLE)cjppDevice)->o_transmit))==0)
			{
			  if(GetLastError()!=ERROR_IO_PENDING)
			  {
				  return CJPP_ERR_DEVICE_LOST;
			  }
			  else if(WaitForSingleObject(((cjppHANDLE)cjppDevice)->o_transmit.hEvent,5000)==WAIT_TIMEOUT)
			  {
				 return CJPP_ERR_WRITE_DEVICE;
			  }
			}
			FlushFileBuffers(((cjppHANDLE)cjppDevice)->hDevice);
//			Sleep(1);
   		if(HighResolution)
			{
				QueryPerformanceCounter(&Start);
				do
				{
   				QueryPerformanceCounter(&Now);
				}while(Now.QuadPart-Start.QuadPart<Count.QuadPart);
			}
			else
			{
				Sleep(1);
			}
			if(WriteFile(((cjppHANDLE)cjppDevice)->hDevice,buffer+5,7+cjppSWAB_DWORD_2(Message->dwLength),&nRet,&(((cjppHANDLE)cjppDevice)->o_transmit))==0)
			{
			  if(GetLastError()!=ERROR_IO_PENDING)
			  {
				  return CJPP_ERR_DEVICE_LOST;
			  }
			  else if(WaitForSingleObject(((cjppHANDLE)cjppDevice)->o_transmit.hEvent,5000)==WAIT_TIMEOUT)
			  {
				 return CJPP_ERR_WRITE_DEVICE;
			  }
			}
			if(WaitForSingleObject(((cjppHANDLE)cjppDevice)->SeriellAckWait,5000)==WAIT_TIMEOUT)
				 return CJPP_ERR_WRITE_DEVICE;
		}while(((cjppHANDLE)cjppDevice)->Connected==1 && ((cjppHANDLE)cjppDevice)->rbuffer[0]!=0xff);
   }
	if(((cjppHANDLE)cjppDevice)->Connected!=1)
      return CJPP_ERR_DEVICE_LOST;   
	return CJPP_SUCCESS;
}



int cjppTransfer(HANDLE cjppDevice,CCID_Message *Message,CCID_Response *Response)
{
   int Res;
	if(((cjppHANDLE)cjppDevice)->Connected!=1)
      return CJPP_ERR_DEVICE_LOST;   
   Res=cjppWrite(cjppDevice,Message);
	if(Res!=CJPP_SUCCESS)
	{
		((cjppHANDLE)cjppDevice)->Connected=0;
		return Res;
	}
   Res=cjppRead(cjppDevice,Response);
	if(Res!=CJPP_SUCCESS)
	{
		((cjppHANDLE)cjppDevice)->Connected=0;
		return Res;
	}
   return CJPP_SUCCESS;
}

int cjppRead(HANDLE cjppDevice,CCID_Response *Response)
{
	ULONG		nRetBytes;

   if(((cjppHANDLE)cjppDevice)->is_usb)
   {
		nRetBytes=0;
		while(nRetBytes==0 || memcmp(Response,"CJCC",4)==0 || memcmp(Response,"\x00\x00\x00\x00",4)==0)
		{
			nRetBytes=0;
			((cjppHANDLE)cjppDevice)->o_receive.Offset=0;
			((cjppHANDLE)cjppDevice)->o_receive.OffsetHigh=0;
			((cjppHANDLE)cjppDevice)->o_receive.Internal=0;
			((cjppHANDLE)cjppDevice)->o_receive.InternalHigh=0;
			ResetEvent(((cjppHANDLE)cjppDevice)->o_receive.hEvent);
			memcpy(Response,"CJCC",4);
			if(ReadFile(((cjppHANDLE)cjppDevice)->hDevice,Response,sizeof(CCID_Response),&nRetBytes,&(((cjppHANDLE)cjppDevice)->o_receive))==0)
			{
				if(GetLastError()!=ERROR_IO_PENDING)
				{
					return CJPP_ERR_DEVICE_LOST;
				}
				GetOverlappedResult(((cjppHANDLE)cjppDevice)->hDevice,&(((cjppHANDLE)cjppDevice)->o_receive),&nRetBytes,TRUE);
			}
		}
	}
	else
	{
		while(((cjppHANDLE)cjppDevice)->Connected==1)
		{
   		if(WaitForSingleObject(((cjppHANDLE)cjppDevice)->SeriellReaderWait,1000)!=WAIT_TIMEOUT)
	   		break;
		}
   	((cjppHANDLE)cjppDevice)->WaitAck=0;
		if(((cjppHANDLE)cjppDevice)->Connected!=1)
         return CJPP_ERR_DEVICE_LOST;   
		memcpy(Response,((cjppHANDLE)cjppDevice)->rbuffer,270);
	}
   return CJPP_SUCCESS;
}


HANDLE cjppCreateThread(void (*ThreadRoutine)(void *),void *Params)
{
   DWORD ThreadId;
   return CreateThread(NULL,0,(  DWORD (WINAPI *)( LPVOID ))ThreadRoutine,Params,0,&ThreadId);
}

void cjppTerminateThread(HANDLE thread)
{
   TerminateThread(thread,0);
}


unsigned long cjppGetUniqueID(void)
{
   UUID uid;
   unsigned long Result;
   unsigned long Help;

   UuidCreate(&uid);
   Result=uid.Data1;
   memcpy(&Help,&uid.Data2,4);
   Result^=Help;
   memcpy(&Help,uid.Data4,4);
   Result^=Help;
   memcpy(&Help,uid.Data4+4,4);
   Result^=Help;
   return Result;
}

